# SQL upgrade script for Anthill 0.1.6 to 0.2.0 (includes all pre-release
# and rc updates)
#
# Remove password salt since we use md5 passwords now
#
DELETE FROM config WHERE id = '19';
#
# Add maximum attachment file size
#
INSERT INTO config (id, name, value) VALUES (19,'maxfsize','2000000');
#
# Add developer access level
#
INSERT INTO config (id, name, value) VALUES (20,'devac','10');
#
# Add default user access level
#
INSERT INTO config (id, name, value) VALUES (21,'defaultac','1');
#
# Remove session column from users table (no longer used)
#
ALTER TABLE users DROP session;
#
# Add cookietimeout
#
ALTER TABLE users ADD cookietimeout int(8) DEFAULT '0';
#
# Add autocc for components
#
ALTER TABLE components ADD autocc varchar(100);
#
# Add system for bugdesc
#
ALTER TABLE bugdesc ADD system int(1) DEFAULT '0';
#
# Add deleted column for users
#
ALTER TABLE users ADD deleted int(1) DEFAULT '0';
#
# Add deleted column for products
#
ALTER TABLE products ADD deleted int(1) DEFAULT '0';
#
# Add deleted column for versions
#
ALTER TABLE versions ADD deleted int(1) DEFAULT '0';
#
# Add deleted column for components
#
ALTER TABLE components ADD deleted int(1) DEFAULT '0';
#
# add mdaemonreplyto to config
#
INSERT INTO config (id, name, value) VALUES (22,'mdaemonreplyto','');
#
# Add fixedver
#
ALTER TABLE bugs ADD fixedver varchar(8) DEFAULT NULL;

#
# Table structure for table 'attachidx'
#

CREATE TABLE attachidx (
  atid int(11) NOT NULL,
  bid int(11) NOT NULL,
  date varchar(14),
  mimetype varchar(30),
  filename varchar(64),
  user int(11),
  PRIMARY KEY (atid)
);

#
# Table structure for table 'sessions'
#

CREATE TABLE sessions (
  sess_id int(10) UNSIGNED DEFAULT '0' NOT NULL,
  start_time int(10) UNSIGNED DEFAULT '0' NOT NULL,
  remote_ip varchar(15) NOT NULL,
  uid int(11) NOT NULL,
  PRIMARY KEY (sess_id),
  KEY sess_id (sess_id),
  KEY start_time (start_time),
  KEY remote_ip (remote_ip)
);
