<?php
  // Anthill
  // $Id: anthill2rss.php,v 1.1 2003/08/27 00:33:35 vdanen Exp $

  // This script generates a RSS feed for a particular project (=product) within
  // Anthill.  It is probably not suitable for public use due to the data exposed
  // however it does make sure that the bug is not private before exporting it, so
  // only publicly-accessible data should be seen.  This is handy, however, for
  // organizations where developers may use a RDF/RSS reader to track Slashdot
  // headlines and you want them to be aware of changes/additions to bugs.

  // Script modified for usage with Anthill by Jilles Oldenbeuving <ojilles@hotmail.com>
  // and based on the script found in cvs rep. of php.net

  // Code-cleanup/integration done by Vincent Danen <vdanen@linsec.ca>

  // Example feed address:
  // http://your-domain-here/anthill/anthill2rss.php?project=1

  // This script is a contribution to Anthill code; bugs should be directed to the author.

include ("/Library/Apache2/htdocs/anthill2/include.php");

// set variables
if (isset($_REQUEST['project'])) { $project = $_REQUEST['project']; } else { $project = NULL; }

if (!isset($project) || !is_numeric($project)) {
  $project = 1;
}

// if you want to force the system to use one particular project alone force $project to the value
// of what you want here:
// $project = 1;


$query  = " SELECT *, users.uname as username, users2.uname as assignedto,"
        . " bugdesc.description as description, versions.name as version"
        . " FROM bugs"
        . " LEFT JOIN users ON bugs.reporter = users.uid"
        . " LEFT JOIN users AS users2 ON bugs.assigned = users2.uid"
        . " LEFT JOIN versions ON bugs.version = versions.vid"
        . " LEFT JOIN bugdesc ON bugdesc.bid = bugs.bid"
        . " WHERE private='0'"
        . " AND bugs.product='".$project."'"
        . " ORDER BY creation DESC, bugdesc.date DESC "
        . " LIMIT 0 , 10"
        ;

$db->query($query);

header("Content-type: text/xml");
print("<?xml version=\"1.0\"?>");
?>
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" 
xmlns="http://my.netscape.com/rdf/simple/0.9/">

<channel>
<title>Anthill</title>
<link><?php print($_CONF['webroot']); ?></link>
<description>An RSS feed of the bugs.</description>
<language>en-us</language>
</channel>

<?php
    while($db->next_record()) {
      print("<item>\n");
      print("<title>[" . $db->record['bid'] . "][" . $db->record['assignedto'] . "] " . $db->record['shortdesc'] . "</title>\n");
      print("<link>" . $_CONF['webroot'] . "query.php?bug=" . $db->record['bid'] . "</link>\n");
      print("<description><![CDATA[" . $db->record['bid'] . ": " . $db->record['shortdesc'] . "<br/><br/>\n");
      print("Submitted by: " . $db->record['username'] . "<br/>\n");
      print("Submitted against version: " . $db->record['version'] . "<br/>\n");
      print("Comment:<br/>\n");
      print(stripslashes(nl2br($db->record['description'])) . "]]></description>\n");
      print("</item>\n");
    }
?>
</rdf:RDF>
<?php $db->free(); ?>
<!-- <?php print($query); ?> -->
