#!/usr/bin/perl

# $Id: makecsv.pl,v 1.1 2003/09/11 02:30:32 vdanen Exp $
# This perl script takes two sources to create a CSV file that contains the
# rpm package (component), summary (short description), and rpm maintainer
# (owner).  The sole argument is a directory that contains all of the RPM
# files to import.

# This script is given as an idea of how to create this file for the
# importrpm.php script also provided.  Both are tailored specifically for
# use for MandrakeSoft bug reporting (see http://bugs.mandrakesoft.com/) but
# can be adapted for use with other situations.

$DIR=$ARGV[0];
$RPMLIST="rpmlist";
$MAINTLIST="maintslist";
$OUTLIST="outlist";

system("rpm -qp $DIR/*.rpm --queryformat=\"%{NAME}\t%{SUMMARY}\n\" >$RPMLIST");
system("lynx -source http://qa.mandrakesoft.com/maints.cgi >$MAINTLIST");

open (RLIST, "$RPMLIST") || die ("Cannot open file $RPMLIST");
open (OLIST, ">$OUTLIST") || die ("Cannot open file $OUTLIST for writing");
while (<RLIST>) {
  $line = $_;
  chop($line);
  @pkg = split(/\t/, $line);
  open (MLIST, "$MAINTLIST") || die ("Cannot open file $MAINTLIST");
  $m = "not found";
  while (<MLIST>) {
    $l = $_;
    chop($l);
    @maint = split(/\t/, $l);
    if ($maint[0] eq $pkg[0]) {
      $m = $maint[1];
    }
  }
  close MLIST;
  $pname = $pkg[0];
  $psum  = $pkg[1];
  $psum  =~ s/,/ /g;
  print OLIST ("$pname,$psum,$m\n");
}
close RLIST;
close OLIST;
