<? 
   // Anthill configuration file
   // during upgrades you probably shouldn't replace this file
   // $Id: config.inc.php,v 1.15 2003/09/30 20:58:52 vdanen Exp $

  ###########################################################################
  # Directory locations:
  #
  # root:	base Anthill directory+html/ (ie. /var/www/anthill/html)
  # incdir:	include directory (full path)
  # webroot:	home url
  # imgdir:	images directory
  # tmpldir:	templates directory
  # langdir:	directory where locale/language files/dirs are kept
  # shadodir:	shadow directory (stores text copy of bugs for diffs)
  # tmpdir:	temporary directory (should be rw to user running the 
  #		web server; ie. apache or nobody)
  # gpgdir:	directory to store GPG keys (should be rw only to web 
  #		server user; located off of the root directory)
  # attachdir:  directory to store attachments (should be rw only to web
  #             server user; located off of the root directory)
  # cssfile:	default stylesheet file
  ###########################################################################

  $_CONF['root']       = "/var/www/html/anthill";
  $_CONF['incdir']     = "/var/www/html/anthill/include";
  $_CONF['webroot']    = "http://localhost";
  $_CONF['imgdir']     = "/images";
  $_CONF['tmpldir']    = "/backend/template";
  $_CONF['langdir']    = "/backend/language";
  $_CONF['shadowdir']  = $_CONF['root'] . "/shadow";
  $_CONF['tmpdir']     = $_CONF['root'] . "/tmp";
  $_CONF['gpgdir']     = "/gpg";
  $_CONF['attachdir']  = "/attachments";
  $_CONF['cssfile']    = $_CONF['webroot'] . "/anthill.css";
  $_CONF['difftool']   = "/usr/bin/diff";

  ###########################################################################
  # Time/date details:
  #
  # datefmt:	  date format to use (see PHP manual for proper syntax)
  # timefmt:	  time format to use (see PHP manual for proper syntax)
  ###########################################################################

  $_CONF['datefmt']     = "Y-m-d";
  $_CONF['timefmt']     = "h:i A";

  ###########################################################################
  # Cookie details:
  #
  # _timeout_permdef: default seconds for cookie expiry for permanent cookies
  #                 (can be overriden by users in their prefs)
  #                 (86400 = one day)
  # _timeout_session: default seconds for session cookie persistence (only
  #                 useful if you don't want persistent cookies)
  # cookie_name:    unique name for the name of the cookie
  # cookie_session: unique name for the session cookie
  # cookie_path:    cookie path (usually just '/')
  # cookie_domain:  the domain in which the cookie should be sent to server
  #                 for (default is $SERVER_NAME, which is the name of the
  #                 running server, but you can change this if you need to)
  # cookie_secure:  0=HTTP, 1=HTTPS (does site run over SSL?)
  ###########################################################################

  $_CONF['cookie_timeout_permdef']    = "86400";
  $_CONF['cookie_timeout_session']    = "7200";
  $_CONF['cookie_name']               = "anthill";
  $_CONF['cookie_session']            = "ant_session";
  $_CONF['cookie_path']               = "/";
  $_CONF['cookie_domain']             = $_SERVER['SERVER_NAME'];
  $_CONF['cookie_secure']             = 0;

  ###########################################################################
  # Language details:
  #
  # meta_lang:	charset to send to browser (meta tag)
  ###########################################################################

  $_CONF['meta_lang'] = "utf-8";

  ###########################################################################
  # SQL connection info:
  #
  # db_user:	SQL username
  # db_pw:	SQL user's password
  # db_host:	SQL server hostname
  # db_name:	SQL database name
  # db_type:    SQL database type ("mysql" or "pgsql"); currently only mysql
  #             is support
  ###########################################################################

  $_CONF['db_user']    = "anthill";
  $_CONF['db_pw']      = "pass";
  $_CONF['db_host']    = "localhost";
  $_CONF['db_name']    = "anthill";
  $_CONF['db_type']    = "mysql";

  #### DO NOT TOUCH ANYTHING BELOW THIS LINE ################################

  if(file_exists($_CONF['incdir'] . "/site.inc.php")) {
    include_once($_CONF['incdir'] . "/site.inc.php");
  } else {
    print("<p><b><font=red>Configuration file doesn't exist!!</font></b></p>");
  }

?>
