<?
  // Anthill functions
  // $Id: functions.inc.php,v 1.100 2003/09/30 20:58:11 vdanen Exp $

  function d_getTime($date) {
    global $_CONF; 
    $year  = substr($date,0,4);
    $mon   = substr($date,4,2);
    $day   = substr($date,6,2);
    $hour  = substr($date,8,2);
    $min   = substr($date,10,2);
    $sec   = substr($date,12,2);
    $gdate = date($_CONF['datefmt'] . " " . $_CONF['timefmt'],mktime($hour,$min,$sec,$mon,$day,$year));
    return($gdate);
  }

  function transsort($sort) {
    // construct an array that contains bugs column name, table name, table column name, table column index name
    switch($sort) {
      case "prod":
        $ret = array('bcolumn' => 'product', 'tname' => 'products', 'tcolumn' => 'name', 'tindex' => 'pid');
        break;
      case "comp":
        $ret = array('bcolumn' => 'component', 'tname' => 'components', 'tcolumn' => 'name', 'tindex' => 'cid');
        break;
      case "pri":
        $ret = array('bcolumn' => 'priority', 'tname' => 'priority_d', 'tcolumn' => 'name', 'tindex' => 'id');
        break;
      case "own":
        $ret = array('bcolumn' => 'assigned', 'tname' => 'users', 'tcolumn' => 'email', 'tindex' => 'uid');
        break;
      case "stat":
        $ret = array('bcolumn' => 'status', 'tname' => 'status_d', 'tcolumn' => 'name', 'tindex' => 'id');
        break;
      case "res":
        $ret = array('bcolumn' => 'resolution', 'tname' => 'resolve_d', 'tcolumn' => 'name', 'tindex' => 'id');
        break;
      case "summ":
        $ret = array('bcolumn' => 'shortdesc', 'tname' => 'bugs', 'tcolumn' => 'shortdesc', 'tindex' => 'bid');
        break;
      default:
        $ret = array('bcolumn' => 'bid', 'tname' => 'bugs', 'tcolumn' => 'bid', 'tindex' => 'bid');
        break;
    }
    return $ret;
  }

  function do_configtest() {
    global $_CONF;
    // run a series of configuration tests
    // test to make sure that things are configured on the system properly
    if (!is_dir($_CONF['shadowdir']) || !is_writable($_CONF['shadowdir'])) {
      print("<p><b><font color=red>" . gettext("shadowdir is not writable; please notify the administrator.") . "</font></b></p>");
    }
    if (!is_dir($_CONF['tmpdir']) || !is_writable($_CONF['tmpdir'])) {
      print("<p><b><font color=red>" . gettext("temporary directory is not writable; please notify the administrator.") . "</font></b></p>");
    }
    $localgpgdir = $_CONF['root'] . $_CONF['gpgdir'];
    if (!is_dir($localgpgdir) || !is_writable($localgpgdir)) {
      print("<p><b><font color=red>" . gettext("gnupg storage directory is not writable; please notify the administrator.") . "</font></b></p>");
    }
    $localattdir = $_CONF['root'] . $_CONF['attachdir'];
    if (!is_dir($localattdir) || !is_writable($localattdir)) {
      print("<p><b><font color=red>" . gettext("attachments directory is not writable; please notify the administrator.") . "</font></b></p>");
    }
    if (ini_get("safe_mode") == 1) { // we are in safe_mode
      if (ini_get("safe_mode_exec_dir") == "") {
        print("<p><b><font color=red>" . gettext("safe_mode enabled, but no safe_mode_exec_dir defined - diff will be unable to run; please notify the administrator.") . "</font></b></p>");
      } else { // let's make sure that our difftool is in the exec_dir
        if (!ereg(ini_get("safe_mode_exec_dir"),$_CONF['difftool'])) {
          print("<p><b><font color=red>" . gettext("diff is not in safe_mode_exec_dir and will not be able to run; please notify the administrator.") . "</font></b></p>");
        }
      }
    }
    // check if php version is 4.1.0 or less
    $pver = intval(str_replace(".", "", phpversion()));
    if ($pver < "410") {
      print("<p><b><font color=red>" . gettext(sprintf("minimum PHP version required is 4.1.0 and you have PHP version %s installed!", phpversion())) . "</font></b></p>");
    }
  }

  function d_StartPage($ptitle) {
    global $_CONF, $rtmpldir, $wtmpldir, $config;

    // force adding charset in PHP headers
    header("Content-Type: text/html; charset=" . $_CONF['meta_lang']);
    ?>
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
    <html>
    <head>
      <title><? print($config['sitename'] . " ");
                if (isset($ptitle)) { print(_NAME . ": " . $ptitle); } ?>
      </title>
      <meta http-equiv="Content-Type" content="text/html; charset=<? print($_CONF['meta_lang']); ?>">
      <meta http-equiv="Pragma" content="no-cache">
      <? // test for themeable stylesheet 
         if (file_exists($rtmpldir . "/" . $config['theme'] . "/style.css")) {
           $_CONF['cssfile'] = $wtmpldir . "/" . $config['theme'] . "/style.css";
         }
      ?> 
      <link rel="stylesheet" href="<? print($_CONF['cssfile']); ?>">
    </head>
    <body bgcolor="<? print($config['bgcol']); ?>"
          text="<? print($config['textcol']); ?>"
          link="<? print($config['linkcol']); ?>"
          vlink="<? print($config['linkcol']); ?>">

    <?
    do_configtest();
  }

  function d_DrawIndex() {
    global $config;

    $sitename     = $config['sitename'];
    $content      = stripslashes($config['siteblurb']);
    t_index($sitename, $content);
  }

  function d_DrawHeader($option) {
    t_header($option);
  }

  function d_DrawNav($ulogin) {
    global $_CONF, $_USER, $config;
    $home         = "index.php";
    $query        = " | <a class=\"navbar\" href=\"query.php\">" . gettext("query bugs") . "</a>";

    $username = NULL; $reg    = NULL; $login  = NULL; $pref = NULL; 
    $logout   = NULL; $submit = NULL; $newbug = NULL; $adm  = NULL;

    if (!isset($ulogin)) {
      $username   = "none";
      $reg        = " | <a class=\"navbar\" href=\"newuser.php\">" . gettext("register") . "</a>";
      $login      = " | <a class=\"navbar\" href=\"login.php\">" . gettext("login") . "</a>";
    } else {
      $username   = $ulogin;
      $pref       = " | <a class=\"navbar\" href=\"pref.php\">" . gettext("preferences") . "</a>";
      $logout     = " | <a class=\"navbar\" href=\"logout.php\">" . gettext("logout") . "</a>";
      $submit     = " | <a class=\"navbar\" href=\"enterbug.php\">" . gettext("submit a bug") . "</a>";
      $newbug     = " | <a class=\"navbar\" href=\"buglist.php?type=mine&myclass=new\">" . gettext("your open bugs") . "</a>"; 
    }
    if ($_USER['access'] >= $config['adminac']) {
      $adm        = " | <a class=\"navbar\" href=\"admin.php\">" . gettext("administration") . "</a>";
    }

    t_nav($home, $query, $submit, $reg, $newbug, $pref, $login, $logout, $username, $adm);
  }

  function d_DrawFooter() {
    global $_CONF;
    $name         = _NAME;
    $version      = _VERSION;
    $copyright    = gettext("Copyright &copy; 2001-2003 <a href=\"http://www.danen.ca/\">Danen Consulting Services</a>; all rights reserved.");
    $weburl       = $_CONF['webroot'];
    t_footer($name, $version, $copyright, $weburl);
  }

  function d_DrawNewUser() {
    global $config;
    $sitename     = $config['sitename'];
    $content      = stripslashes($config['newublurb']);
    $name         = _NAME;
    $form         = "newuser.php";
    t_newuser($sitename, $content, $name, $form);
  }

  function d_DrawQueryForm($uid) {
    global $config, $db;
    $sitename = $config['sitename'];
    // get status
    $statopts = NULL; $useropts = NULL; $user2opts = NULL; $prodopts = NULL;
    $count    = 0;
    $db->query("SELECT * FROM status_d");
    while ($db->next_record()) {
      $status[$count] = array("id" => $db->record['id'], "name" => $db->record['name']);
      $count++;
    }
    while (list($key, $val) = each($status)) {
      $statopts .= sprintf("<option value=\"%s\">%s</option>", $val['id'],$val['name']);
    }
    // get products
    $count    = 0;
    $db->query("SELECT * FROM products WHERE deleted = '0'");
    while ($db->next_record()) {
      $prod[$count] = array("id" => $db->record['pid'], "name" => $db->record['name']);
      $count++;
    }
    while (list($key, $val) = each($prod)) {
      $prodopts .= sprintf("<option value=\"%s\">%s</option>", $val['id'],$val['name']);
    }
    // get users
    $count    = 0;
    $db->query("SELECT * FROM users WHERE deleted = '0'");
    while ($db->next_record()) {
      $user[$count] = array("uid" => $db->record['uid'], "email" => $db->record['email']);
      $count++;
    }
    while (list($key, $val) = each($user)) {
      $useropts .= sprintf("<option value=\"%s\">%s</option>", $val['uid'],$val['email']);
    }
    // get users without current user
    $count    = 0;
    $db->query("SELECT * FROM users WHERE (uid != '$uid') AND (deleted = '0')");
    while ($db->next_record()) {
      $user2[$count] = array("uid" => $db->record['uid'], "email" => $db->record['email']);
      $count++;
    }
    if (is_array($user2)) {
      while (list($key, $val) = each($user2)) {
        $user2opts .= sprintf("<option value=\"%s\">%s</option>", $val['uid'],$val['email']);
      }
    } else {
      $user2opts = "";
    }
    t_queryform($sitename, $statopts, $useropts, $user2opts, $prodopts);
  }

  function d_DrawPref($uid) {
    global $_CONF, $config, $db;

    $db->query("SELECT * FROM users WHERE uid = '$uid'");
    $db->next_record();
    $user  = $db->record;

    $sitename     = $config['sitename'];
    $content      = stripslashes($config['prefblurb']);
    $form         = "pref.php";
    $uname        = $user['uname'];
    $rname        = $user['name'];
    $email        = $user['email'];
    $cookieval    = $user['cookietimeout'];
    $laston       = $user['laston'];
    $epref        = $user['epref'];
    if ($laston == "") {
      $laston     = gettext("This is your first login");
    }
    // get gpg info
    if (isset($user['gpg'])) {
      $fp        = fopen($_CONF['root'] . $user['gpg'], "r");
      $gpg       = fread($fp, filesize($_CONF['root'] . $user['gpg']));
      fclose($fp);
      $dkeyform  = "<form method=\"post\" action=\"" . $form . "\">\n";
      $dkeyform .= "<input type=\"hidden\" name=\"go\" value=\"deletekey\">\n";
      $dkeyform .= "<input type=\"submit\" value=\"" . gettext("Delete Key") . "\"></form>\n";
    } else {
      $gpg      = "";
      $dkeyform = "";
    }

    t_pref($sitename, $content, $form, $uname, $rname, $email, $laston, $uid, $gpg, $dkeyform, $cookieval, $epref);
    $db->free();
  }

  function d_DrawLogin($caller) {
    $form = "login.php";
    t_login($form, $caller);
  }

  function d_DrawEditProd($what, $pid) {
    global $db;

    // we can have two possible values of $what: insert or change
    if ($what == "insert") {
      $button = gettext("Add");
    } elseif ($what == "change") {
      $button = gettext("Change");
    } else {
      print("invalid call to d_DrawEditProd()");
      exit;
    }
    $db->query("SELECT * FROM products WHERE pid = '$pid'");
    $db->next_record();
    $product  = $db->record;
?>
    <form method="post" action="editproducts.php">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Product")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="name" size="50" maxlength="64" value="<? print($product['name']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Description")); ?>:
        </td>
        <td width="50%">
          <textarea name="description" cols="50" rows="2" wrap="Virtual"><? print($product['description']); ?></textarea>
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <input type="submit" value="<? print($button); ?>">
          <input type="hidden" name="action" value="<? print($what); ?>">
          <input type="hidden" name="pid" value="<? print($pid); ?>">
        </td>
        <td width="50%">
          &nbsp;
        </td>
      </tr>
    </table>
    </form>
<?
  $db->free();
  }

  function d_DrawEditVer($what, $vid, $pid) {
    global $db;

    // we can have two possible values of $what: insert or change
    if ($what == "insert") {
      $button = gettext("Add");
    } elseif ($what == "change") {
      $button = gettext("Change");
    } else {
      print("invalid call to d_DrawEditVer()");
      exit;
    }
    $db->query("SELECT * FROM versions WHERE vid = '$vid'");
    $db->next_record();
    $version = $db->record;
?>
    <form method="post" action="editversions.php">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Version")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="name" size="50" maxlength="64" value="<? print($version['name']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <input type="submit" value="<? print($button); ?>">
          <input type="hidden" name="action" value="<? print($what); ?>">
          <input type="hidden" name="vid" value="<? print($vid); ?>">
          <input type="hidden" name="pid" value="<? print($pid); ?>">
        </td>
        <td width="50%">
          &nbsp;
        </td>
      </tr>
    </table>
    </form>
<?
  $db->free();
  }

  function d_DrawEditComp($what, $cid, $pid) {
    global $db, $config;

    // we can have two possible values of $what: insert or change
    if ($what == "insert") {
      $button = gettext("Add");
    } elseif ($what == "change") {
      $button = gettext("Change");
    } else {
      print("invalid call to d_DrawEditComp()");
      exit;
    }
    $db->query("SELECT * FROM components WHERE cid = '$cid'");
    $db->next_record();
    $component = $db->record;
    $owner     = $component['owner'];
    $db->free();
    $db->query("SELECT * FROM users WHERE uid = '$owner'");
    $db->next_record();
    $uid       = $db->record;
?>
    <form method="post" action="editcomponents.php">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Component")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="name" size="50" maxlength="64" value="<? print($component['name']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Description")); ?>:
        </td>
        <td width="50%">
          <textarea name="description" cols="50" rows="2" wrap="Virtual"><? print($component['description']); ?></textarea>
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Initial Owner")); ?>:
        </td>
        <td width="50%">
          <select name="owner" value="<? print($uid['uid']); ?>">
          <? $db->free();
             $db->query("SELECT * FROM users WHERE (access >= '" . $config['devac'] . "') AND (deleted = '0')");
             while ($db->next_record()) {
               $user = $db->record;
               $sel  = "";
               if ($uid['uid'] == $user['uid']) {
                 $sel = "selected";
               }
               print(sprintf("<option value=\"%s\" %s>%s</option>\n",$user['uid'],$sel,$user['email']));
             }
          ?>
          </select>         
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Auto CC (separate by commas)")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="autocc" size="50" maxlength="100" value="<? print($component['autocc']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <input type="submit" value="<? print($button); ?>">
          <input type="hidden" name="action" value="<? print($what); ?>">
          <input type="hidden" name="cid" value="<? print($cid); ?>">
          <input type="hidden" name="pid" value="<? print($pid); ?>">
        </td>
        <td width="50%">
          &nbsp;
        </td>
      </tr>
    </table>
    </form>
    <p><? print(gettext("Auto CC is used to automatically add email addresses to new bugs assigned to this component.  This is a comma delimited list (ie. 'joe@user.com,jim@other.com')")); ?></p>
<?
  $db->free();
  }

  function d_DrawEditUser($moduserid) {
    global $config, $db;

    $db->query("SELECT * FROM users WHERE uid = '$moduserid'");
    $db->next_record();
    $utmp  = $db->record;
?>
    <form method="post" action="editusers.php">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
        <td width="50%" align="right">
          <? print(gettext("User Name")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="uname" size="50" maxlength="64" value="<? print($utmp['uname']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Real Name")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="name" size="50" maxlength="64" value="<? print($utmp['name']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Email Address")); ?>:
        </td>
        <td width="50%">
          <input type="text" name="email" size="50" maxlength="64" value="<? print($utmp['email']); ?>">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("Access Level")); ?>:
        </td>
        <td width="50%">
          <select name ="access">
            <option value="<? print($config['defaultac']); ?>" <? if ($utmp['access'] == $config['defaultac']) { print("SELECTED"); } ?>><? print(gettext("Basic User")); ?></option>
            <option value="<? print($config['devac']); ?>" <? if ($utmp['access'] == $config['devac']) { print("SELECTED"); } ?>><? print(gettext("Developer")); ?></option>
            <option value="<? print($config['adminac']); ?>" <? if ($utmp['access'] == $config['adminac']) { print("SELECTED"); } ?>><? print(gettext("Administrator")); ?></option>
          </select>
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("New Password")); ?>:
        </td>
        <td width="50%">
          <input type="password" name="pass1" size="50" maxlength="64" value="">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <? print(gettext("New Password (re-enter)")); ?>:
        </td>
        <td width="50%">
          <input type="password" name="pass2" size="50" maxlength="64" value="">
        </td>
      </tr>
      <tr>
        <td width="50%" align="right">
          <input type="submit" value="<? print(gettext("Change")); ?>">
          <input type="hidden" name="action" value="change">
          <input type="hidden" name="moduserid" value="<? print($moduserid); ?>">
        </td>
        <td width="50%">
          &nbsp;
        </td>
      </tr>
    </table>
    </form>
<?
  $db->free();
  }

  function d_DrawCAttach($bug) {
    global $config;

    t_cattach($bug, $config['maxfsize']);
  }

  function d_DoDiff($bugnum) {
    global $_CONF, $config, $db, $_USER;

    $db2         = new db_Sql();
    $db2->host   = $_CONF['db_host'];
    $db2->dbase  = $_CONF['db_name'];
    $db2->user   = $_CONF['db_user'];
    $db2->passwd = $_CONF['db_pw'];
    $db2->connect();

    $db->query("SELECT * FROM bugs WHERE bid = '$bugnum'");
    $db->next_record();
    $bug      = $db->record;
    $db->free();
    $db->query("SELECT * FROM users WHERE uid = '" . $bug['assigned'] . "'");
    $db->next_record();
    $assigned = $db->record['email'];
    $db->free();
    $db->query("SELECT * FROM users WHERE uid = '" . $_USER['uid'] . "'");
    $db->next_record();
    $callinguser = NULL;
    if ($db->record['epref'] == 0) { // user doesn't want to receive their changes
      $callinguser = $db->record['email'];
    }
    $db->query("SELECT * FROM users WHERE uid = '" . $bug['reporter'] . "'");
    $db->next_record();
    $reported = $db->record['email'];
    $db->free();
    $db->query("SELECT * FROM status_d WHERE id = '" . $bug['status'] . "'");
    $db->next_record();
    $statx    = $db->record['name'];
    $db->free();
    if ($bug['resolution'] != "") {
      $db->query("SELECT * FROM resolve_d WHERE id = '" . $bug['resolution'] . "'");
      $db->next_record();
      $resolve = $db->record['name'];
      $db->free();
      if ($bug['fixedver'] != "") {
        $fixver = $bug['fixedver'];
      } else {
        $fixver = NULL;
      }
    } else {
      $resolve = NULL;
    }
    $db->query("SELECT * FROM priority_d WHERE id = '" . $bug['priority'] . "'");
    $db->next_record();
    $priority = $db->record['name'];
    $db->free();
    $db->query("SELECT * FROM components WHERE cid = '" . $bug['component'] . "'");
    $db->next_record();
    $compt    = $db->record['name'];
    $db->free();
    $db->query("SELECT * FROM products WHERE pid = '" . $bug['product'] . "'");
    $db->next_record();
    $product  = $db->record['name'];
    $db->free();
    $db->query("SELECT * FROM versions WHERE vid = '" . $bug['version'] . "'");
    $db->next_record();
    $version  = $db->record['name'];
    $db->free();

    if ($bug['private'] == 0) {
      $priv   = gettext("PUBLIC");
    } else {
      $priv   = gettext("PRIVATE");
    }

      // get the maximum string length to format the email nicely
      // we do not use gettext here; all diffs are abitrarily in english
      // (this prevents multi-language erroneous diffs if users use
      // different languages)
      $msg[0]   = "Bug#";
      $msg[1]   = "Product";
      $msg[2]   = "Version";
      $msg[3]   = "Status";
      $msg[4]   = "Priority";
      $msg[5]   = "Component";
      $msg[6]   = "URL";
      $msg[7]   = "Assigned To";
      $msg[8]   = "Reported By";
      $msg[9]   = "Type";
      $msg[10]  = "Summary";
      $msg[11]  = "Resolution";
      $msg[12]  = "Fixed Ver";
      $limit    = count($msg);
      $size     = 0;
      for ($i=0; $i < $limit; $i++) {
        if (strlen($msg[$i]) > $size) {
          $size = strlen($msg[$i]);
        }
      }
      for ($i=0; $i < $limit; $i++) {
        $buff = $size - strlen($msg[$i]);
        if ($buff > 0) {
          $msg[$i] = $msg[$i] . str_repeat(" ", $buff);
        }
      }

    // need to find way to format a little nicer dependant on length of
    // defined strings
    $tmpdesc    = $msg[0]  . ": " . stripslashes($bugnum) . "\n";
    $tmpdesc   .= $msg[1]  . ": " . stripslashes($product) . "\n";
    $tmpdesc   .= $msg[2]  . ": " . stripslashes($version) . "\n";
    $tmpdesc   .= $msg[3]  . ": " . $statx . "\n";
    if (isset($resolve)) {
      $tmpdesc .= $msg[11] . ": " . $resolve . "\n";
      $tmpdesc .= $msg[12] . ": " . $fixver . "\n";
    }
    $tmpdesc   .= $msg[4]  . ": " . $priority . "\n";
    $tmpdesc   .= $msg[5]  . ": " . stripslashes($compt) . "\n";
    $tmpdesc   .= $msg[6]  . ": " . stripslashes($bug['url']) . "\n";
    $tmpdesc   .= $msg[7]  . ": " . $assigned . "\n";
    $tmpdesc   .= $msg[8]  . ": " . $reported . "\n";
    $tmpdesc   .= $msg[9]  . ": " . $priv . "\n\n";
    $tmpdesc   .= $msg[10] . ": " . stripslashes($bug['shortdesc']) . "\n\n";

    $db->query("SELECT * FROM bugdesc WHERE bid = '" . $bug['bid'] . "'");
    while ($db->next_record()) {
      $ldesc    = $db->record; 
      $db2->query("SELECT * FROM users WHERE uid = '" . $ldesc['user'] . "'");
      $db2->next_record();
      $rep      = $db2->record;
      $tmpdesc .= sprintf("Comment posted: %s by %s", d_getTime($ldesc['date']), $rep['email']) . "\n\n";
      $tmpdesc .= stripslashes($ldesc['description']) . "\n\n";
      $db2->free();
    }
    $db->free();

    $oldfile = $_CONF['shadowdir'] . "/" . $bugnum;
    $tmpfile = tempnam($_CONF['shadowdir'],$bugnum . ".tmp.");
    if (file_exists($tmpfile)) {
      $fp = fopen($tmpfile, "w");
      fwrite($fp, $tmpdesc);
      fclose($fp);
    } else {
      print("<p><font color=red>" . gettext("Error: Cannot open temporary file.") . "</font></p>");
    }

    // create oldfile if it doesn't exist otherwise diff will not create the
    // initial diff file
    if (!file_exists($oldfile)) {
      $fp = fopen($oldfile, "w");
      fwrite($fp, "");
      fclose($fp);
    }

    // create the diff
    $stmpfile = ereg_replace($_CONF['shadowdir'] . "/","",strtr(addcslashes($tmpfile, "\0..\37!@\177..\377"), "\\", "/"));
    $antdiff  = tempnam($_CONF['tmpdir'],"ant-diff.");
    $cmd      = sprintf("%s -ruN %s/$bugnum %s/$stmpfile",$_CONF['difftool'],$_CONF['shadowdir'],$_CONF['shadowdir']);
    $output   = exec($cmd,$diffarray,$return);
    if ($return == 1) { // there are differences
      $x = implode($diffarray,"\n");
      $x = ereg_replace($_CONF['shadowdir']."/","",$x);
    } else {
      $x = "";
    }
    if (file_exists($antdiff)) {
      $fp = fopen($antdiff, "w");
      fwrite($fp, $x);
      fclose($fp);
    } else {
      print("<p><font color=red>" . gettext("Error: Cannot open diff file.") . "</font></p>");
    }

    // move new bug desc file to old
    unlink($oldfile) or die ("Cannot delete $oldfile");
    rename($tmpfile, $oldfile) or die ("Cannot rename $tmpfile to $oldfile");

    // send email to assigned user and all cc's
    $message = $_CONF['webroot'] . "/query.php?bug=" . $bugnum . "\n\n";
    $db->query("SELECT * FROM bugs WHERE bid = '$bugnum'");
    $db->next_record();
    $bugx    = $db->record;
    $db->free();

    $diffmsg  = file($antdiff);
    $q        = $_CONF['webroot'] . "/query.php";
    $diffmsg  = str_replace("query.php", $q, $diffmsg);
    $s        = $_CONF['webroot'] . "/showattachment.php";
    $diffmsg  = str_replace("showattachment.php", $s, $diffmsg);

    // delete diff file after use
    unlink($antdiff) or die ("Cannot delete $antdiff");

    $diffnum  = count($diffmsg);
    if ($diffnum == 0) {
      print("<span class=\"text\"><font color=\"red\">" . gettext("There was an error or you entered no information when saving changes; diff is empty!") . "</font></span>");
    }
    $footer   = str_replace("<br>", "\n", stripslashes($config['emailfooter']));
    $message .= implode($diffmsg, "");
    $message .= "\n\n$footer";

    $db->query("SELECT * FROM users WHERE uid = '" . $bugx['assigned'] . "'");
    $db->next_record();
    $userx  = $db->record;
    $db->free();

    // make our cc list, try and remove all duplicate addresses 
    $cclist = $userx['email'] . ", " . $reported;
    if ($bugx['cc'] != "") { // make sure we don't add an extra ", " to the list this way
      $cclist = $cclist . ", " . $bugx['cc'];
    }
    $cclist = explode(", ",$cclist);
    $tempcc = array_unique($cclist);
    $cc     = array();
    foreach ($tempcc as $element) {
      if($element != $callinguser) { // user doesn't want mail
          array_push($cc, $element);
      }
    }
 
/*
    $tempcc = "";
    for ($i=0; $i < count($cclist); $i++) {
      $pattern = ereg_replace("@","\@",$cclist[$i]);
      if (is_array($cc)) $tempcc = implode($cc, ", ");
      if ($cclist[$i] != $userx['email'] || !ereg($pattern, $tempcc)) {
        if (is_array($cc)) $tempcc = implode($cc, ", ");
#          if (!ereg($pattern, $tempcc)) {
            if ($cclist[$i] != $userx['email']) {
              $cc[$i] = $cclist[$i];
#            }
          }
      }
    }
*/
    // reconstruct the list
    if (count($cc) > 1) { // more than one recipient
      $emailto = $cc[0];
      unset($cc[0]);
      $cc = implode($cc, ", ");
    } else {
      $emailto = $cc[0];
      $cc = "";
    }
    if ($config['mdaemonreplyto'] != "") {
      $replyto = "Reply-To: " . $config['mdaemonreplyto'] . "\n";
    } else {
      $replyto = "";
    }
    if ($emailto != "") {
      $retval = @mail($emailto,
              "[Bug #" . $bugnum . "] [" . stripslashes($compt) . "] " . stripslashes($bug['shortdesc']), $message,
              "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">\nCC: " . $cc . "\n" . $replyto . "Return-Path: <" . $config['memail'] . ">\r\nX-Mailer: " . _NAME . " " . _VERSION);
    }
  }

  function d_DoSearchList($search, $sort, $order) {
    global $user, $db;

    $sortorder = transsort($sort);

    $c      = 0;
    $bcol   = "#ffffff";
    // query retrieves only the bugid (bid)
    $count  = 0;
    if ($sortorder['tname'] == "bugs") {
      $j     = "";
      $join  = "";
      $sord  = " $order";
    } else {
      $j     = "(";
      $join  = "LEFT JOIN " . $sortorder['tname'] . " ON bugs." . $sortorder['bcolumn'];
      $join .= " = " . $sortorder['tname'] . "." . $sortorder['tindex'] . ") ";
      $sord  = " $order,bugs.bid ASC";
    }
    
        if ($sortorder['tname'] == "bugs") {
      $j     = "";
      $join  = "";
      $sord  = " $order";
    } else {
      $j     = "(";
      $join  = "LEFT JOIN " . $sortorder['tname'] . " ON bugs." . $sortorder['bcolumn'];
      $join .= " = " . $sortorder['tname'] . "." . $sortorder['tindex'] . ") ";
      $sord  = " $order,bugs.bid ASC";
    }
    
    $query  = "SELECT DISTINCT(bugs.bid) AS bugid FROM " . $j . "(bugs LEFT JOIN bugdesc ON bugs.bid = bugdesc.bid) ";
    $query .= $join;
    $query .= "WHERE (bugs.shortdesc like '%$search%' ";
    $query .= "OR bugs.shortdesc like '$search%' ";
    $query .= "OR bugs.shortdesc like '%$search' ";
    $query .= "OR bugdesc.description like '%$search%' ";
    $query .= "OR bugdesc.description like '$search%' ";
    $query .= "OR bugdesc.description like '%$search') ";
    $query .= "ORDER BY " . $sortorder['tname'] . "." . $sortorder['tcolumn'] . $sord;

    $db->query($query);
    while ($db->next_record()) {
      $btmp[$count] = $db->record['bugid'];
      $count++;
    }
    $db->free();

    $lastbid = 0;
    $x       = 0;
    for ($i=0; $i<count($btmp); $i++) {
      if ($btmp[$i] != $lastbid) {
        $db->query("SELECT * FROM bugs WHERE bid = '" . $btmp[$i] . "'");
        $db->next_record();
        $bugs = $db->record;
        if ($bugs['private'] == 1 && !isset($user['uid'])) {
          continue;
        }
        $db->free();
        $x++;
        // set background row color (make a pref later?)
        if ($c == 0) {
          $bcol = "#ffffff";
          $c    = 1;
        } else {
          $bcol = "#e7e7e7";
          $c    = 0;
        }
?>
    <tr bgcolor="<? print($bcol); ?>">
      <td valign="top">
        <a href="query.php?bug=<? print($bugs['bid']); ?>"><? print($bugs['bid']); ?></a>&nbsp;
      </td>
      <td valign="top">
        <? $db->query("SELECT * FROM products WHERE pid = '" . $bugs['product'] . "'");
           $db->next_record();
           print($db->record['name']);
           $db->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db->query("SELECT * FROM components WHERE cid = '" . $bugs['component'] . "'");
           $db->next_record();
           print($db->record['name']);
           $db->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db->query("SELECT * FROM priority_d WHERE id = '" . $bugs['priority'] . "'");
           $db->next_record();
           print($db->record['name']);
           $db->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db->query("SELECT * FROM users WHERE uid = '" . $bugs['assigned'] . "'");
           $db->next_record();
           print($db->record['email']);
           $db->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db->query("SELECT * FROM status_d WHERE id = '" . $bugs['status'] . "'");
           $db->next_record();
           print($db->record['name']);
           $db->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? if ($bugs['resolution'] != "") {
             $db->query("SELECT * FROM resolve_d WHERE id = '" . $bugs['resolution'] . "'");
             $db->next_record();
             print($db->record['name']);
             $db->free();
           }
        ?>&nbsp;
      </td>
      <td valign="top">
        <? print(stripslashes($bugs['shortdesc'])); ?>
      </td>
    </tr>
<?
      }
      $lastbid = $btmp[$i];
    }
  return($x);
  }

  function d_DoBugList($where, $sort, $order) {
    global $user, $_CONF, $db;

    $sortorder = transsort($sort);

    $db2         = new db_Sql();
    $db2->host   = $_CONF['db_host'];
    $db2->dbase  = $_CONF['db_name'];
    $db2->user   = $_CONF['db_user'];
    $db2->passwd = $_CONF['db_pw'];
    $db2->connect();

    $c      = 0;
    $bcol   = "#ffffff";
    
    if ($sortorder['tname'] == "bugs") {
      $j     = "";
      $join  = "";
      $sord  = " $order";
    } else {
      $j     = "(";
      $join  = "LEFT JOIN " . $sortorder['tname'] . " ON bugs." . $sortorder['bcolumn'];
      $join .= " = " . $sortorder['tname'] . "." . $sortorder['tindex'] . ") ";
      $sord  = " $order,bugs.bid ASC";
    }
    $query  = "SELECT * FROM ". $j . "bugs " . $join . " " . $where;
    $query .= "ORDER BY " . $sortorder['tname'] . "." . $sortorder['tcolumn'] . $sord;   
    $db->query($query);
    $count   = 0;
    while ($db->next_record()) {
      $bugs = $db->record;
      if ($bugs['private'] == 1 && !isset($user['uid'])) {
        continue;
      }
      $count++;
      // set background row color (make a pref later?)
      if ($c == 0) {
        $bcol = "#ffffff";
        $c    = 1;
      } else {
        $bcol = "#e7e7e7";
        $c    = 0;
      }
?>
    <tr bgcolor="<? print($bcol); ?>">
      <td valign="top">
        <a href="query.php?bug=<? print($bugs['bid']); ?>"><? print($bugs['bid']); ?></a>&nbsp;
      </td>
      <td valign="top">
        <? $db2->query("SELECT * FROM products WHERE pid = '" . $bugs['product'] . "'");
           $db2->next_record();
           print($db2->record['name']);
           $db2->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db2->query("SELECT * FROM components WHERE cid = '" . $bugs['component'] . "'");
           $db2->next_record();
           print($db2->record['name']);
           $db2->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db2->query("SELECT * FROM priority_d WHERE id = '" . $bugs['priority'] . "'");
           $db2->next_record();
           print($db2->record['name']);
           $db2->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db2->query("SELECT * FROM users WHERE uid = '" . $bugs['assigned'] . "'");
           $db2->next_record();
           print($db2->record['email']);
           $db2->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? $db2->query("SELECT * FROM status_d WHERE id = '" . $bugs['status'] . "'");
           $db2->next_record();
           print($db2->record['name']);
           $db2->free();
        ?>&nbsp;
      </td>
      <td valign="top">
        <? if ($bugs['resolution'] != "") {
             $db2->query("SELECT * FROM resolve_d WHERE id = '" . $bugs['resolution'] . "'");
             $db2->next_record();
             print($db2->record['name']);
             $db2->free();
           }
        ?>&nbsp;
      </td>
      <td valign="top">
        <? print(stripslashes($bugs['shortdesc'])); ?>
      </td>
    </tr>
<?
    }
  return($count);
  }

  function d_mailUser($subject) {
    global $config, $db, $_CONF;

    $bugurl = $_CONF['webroot'] . "/query.php?bug=BUG";

    switch($subject) {
      case "NEW":
        $msg   = sprintf(gettext("There are new bugs assigned to you.  Please accept them or assign them to\nsomeone else by going to %s\n\n"), $bugurl);
        $query = "SELECT assigned, shortdesc, bid FROM bugs WHERE status = '1'";
        break;
      case "UNRESOLVED":
        $msg   = sprintf(gettext("There are unresolved bugs assigned to you. This is a reminder that you\nhave open bugs in the bug system.\n\n%s\n\n"), $bugurl);
        $query = "SELECT assigned, shortdesc, bid FROM bugs WHERE (status = '2' OR status = '3' OR status = '5')";
        break;
    }

    $db->query($query);
    if ($db->num_rows() > 0) {
      $db2         = new db_Sql();
      $db2->host   = $_CONF['db_host'];
      $db2->dbase  = $_CONF['db_name'];
      $db2->user   = $_CONF['db_user'];
      $db2->passwd = $_CONF['db_pw'];
      $db2->connect();
      while($db->next_record()) {
        $bid       = $db->record['bid'];
        $shortdesc = stripslashes($db->record['shortdesc']);
        $assigned  = $db->record['assigned'];
        $db2->query("SELECT email FROM users WHERE uid = '$assigned'");
        $db2->next_record();
        $email     = $db2->record['email'];
        $db2->free();
        $db2->query("SELECT user, description FROM bugdesc WHERE bid = '$bid' ORDER BY date LIMIT 1");
        $db2->next_record();
        $rid       = $db2->record['user'];
        $ldesc     = $db2->record['description'];
        $db2->free();
        $db2->query("SELECT email FROM users WHERE uid = '$rid'");
        $db2->next_record();
        $reporter  = $db2->record['email'];
        $db2->free();

        $message  = str_replace("BUG","$bid",$msg);
        $message .= "\n\nReported by: $reporter";
        $message .= "\n\nShort Description:\n$shortdesc";
        $message .= "\n\nLong Description:\n" . stripslashes($ldesc);
        $message .= "\n\n--\n" . $_CONF['webroot'];

        $retval = @mail($email, "[$subject BUG #$bid] $shortdesc", $message,
                        "From: " . $config['mdaemon'] . " <" . $config['memail'] . ">\r\nReturn-Path: <" . $config['memail'] . ">\r\nX-Mailer: " . _NAME . " " . _VERSION);
      }
    }
    $db->free();
  }
  
  function d_TransURL($url, $blank) {
    // if this is an escaped url (ie. someone entered it using <a href="">bla</a> do not htmlize it as
    // a) it would be bad form and b) it looks horrible.
    if (ereg(".*lt;a\ href.*quot;.*gt;.*",$url) || ereg(".*quot;.*gt;.*",$url)) return($url);
    if ($blank==1) {
      $trans = preg_replace("/((http(s?):\/\/)|(www\.))([\S\.]+)\b/i",
        "<a href=\"http$3://$4$5\" target=\"_blank\">$2$4$5</a>", $url);
    } else {
      $trans = preg_replace("/((http(s?):\/\/)|(www\.))([\S\.]+)\b/i",
        "<a href=\"http$3://$4$5\">$2$4$5</a>", $url);
    }
    return($trans);
  }

  function z_MakeDropDown($formField, $lookupTable, $lookupField, $lookupDisplay, $nodeleted) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;
    if ($nodeleted == 1) {
      $query = "SELECT $lookupField,$lookupDisplay FROM $lookupTable WHERE deleted = '0'";
    } else {
      $query = "SELECT $lookupField,$lookupDisplay FROM $lookupTable";
    }
    $db->query($query);
    $result  = "<select size=1 name=\"$formField\">";
    $result .= "<option value=-1> * All " . ucfirst($lookupTable) . "</option>";
    while ($db->next_record()) {
      $result .= "<option value=\"" . $db->record[$lookupField] . "\"> " . $db->record[$lookupDisplay] . "</option> "; 
    }
    $db->free();
    $result .= "</select>";
    return($result);
  }

  function z_MakeDateRangeDropDown($formField) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $today = getdate(); 
    $month = $today['month']; 
    $mday  = $today['mday']; 
    $year  = $today['year']; 

    $months = array("1"=>"January","2"=>"Febuary","3"=>"March","4"=>"April",
		    "5"=>"May","6"=>"June","7"=>"July","8"=>"August",
		    "9"=>"September","10"=>"October","11"=>"November","12"=>"December");

    $result = "<select name=\"$formField" . "_day\">";
    for ($i=1; $i<32; $i++) {
      $result .= "<option value=\"$i\"> $i </option>";
    }
    $result .= "</select> ";

    $result .= "<select name=\"$formField" ."_month\">";
    while (list($month, $month_name) = each($months)) {
      $result .= "<option value=\"$month\"> $month_name </option> ";
    }
    $result .= "</select> ";

    $result .= "<select name=\"$formField" . "_year\">";
    for ($i=2001; $i<($year+1); $i++) {
      $result .= "<option value=\"$i\"> $i </option>";
    }
    $result .= "</select> ";
    return($result);
  }


  function z_MakeFieldCheckBoxes($TableName) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;
    $db->query("SELECT * FROM $TableName LIMIT 1");
    for ($i=0; $i<$db->num_rows(); $i++) {
      $db->next_record();
      $meta = $db->record();
      if ($meta) {
        $result .= "<INPUT TYPE=\"checkbox\" NAME=\"show_" . $meta['name'] . "\" CHECKED>" . $meta['name'];
      }
    }
    return($result);
  }

  function z_MakeSelectFieldsList($TableName) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;
    $db->query("SELECT * FROM $TableName LIMIT 1");
    $db->next_record();
    $num_fields = $db->num_fields();
    $c=4;
    $t=0;
    $result="\n<table border=0 width=\"100%\" cellspacing=2>\n\t<tr>\n";
    for ($nSort=0; $nSort<$num_fields; $nSort++) { 
      if ($t == $c) {
	$result.="\t</tr>\n\t<tr>\n";
	$t=0;
      }
      $result .= "\t\t<td align=right width=15 valign=middle bgcolor=#bac2ca>". (string)($nSort+1) .".</td>\n";
      $result .= "\t\t<td align=center bgcolor=#bac2ca>\n\t\t\t<SELECT NAME=\"show_$nSort\" SIZE=1>\n";
      $options = '';
      for ($i=0; $i<$num_fields; $i++) {
        $meta = $db->fetch_fieldname($i);
        if ($meta) {    
          // print "\n nSort = $nSort , i = $i  ";
          if ($i == $nSort) { 
            $IS_SELECTED = 'SELECTED';
          } else {
            $IS_SELECTED= '';
          }
          $options .= "\t\t\t\t<OPTION VALUE=\"" . $meta . "\" $IS_SELECTED> " . $meta . "\n";
        }
     }
     $result .= $options;
     $result .= "\t\t\t\t<OPTION VALUE=\"\" SIZE=1> -------- \n";
     $result .= "\t\t\t</SELECT> \n\t\t</td>\n";
     $t++;
   }
   if ($t == $c) {
     $result.="\t</tr>\n</table>\n";
   } else {
     $r=($c - $t)*2;
     $result.="\t\t<td colspan=$r bgcolor=#bac2ca><hr width=75%></td>\n\t</tr>\n</table>\n";
   }
   return($result);
  }

  function z_MakeSortFieldsList($TableName) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $db;
    $result = ''; $options = '';
    $db->query("SELECT * FROM $TableName LIMIT 1");
    $c=4;
    $t=0;
    $result="<table border=0 cellspacing=2 width=\"100%\">\n\t<tr>\n";
    for ($i=0 ; $i<$db->num_fields(); $i++) {
      $meta = $db->fetch_fieldname($i); 
      if ($meta) {
        $options .= "\t\t\t\t<OPTION VALUE=\"" . $meta . "\"> " . $meta . "\n";
      }
    }

    for ($nSort=1; $nSort<13 ; $nSort++) {
      if ($t == $c) {
	$result.="\t</tr>\n\t<tr>\n";
	$t=0;
      }
      $result .= "\t\t<td align=right width=15 valign=middle bgcolor=#bac2ca>$nSort.</td>\n";
      $result .= "\t\t<td align=center bgcolor=#bac2ca>\n\t\t\t<SELECT NAME=\"sort_$nSort\" SIZE=1>\n";
      $result .= "\t\t\t\t<OPTION VALUE=\"\" SIZE=1 SELECTED> -------- \n";
      $result .= $options;
      $result .= "\t\t\t</SELECT> \n";
      $t++;
    }
   if ($t == $c) {
     $result.="\t</tr>\n</table>\n";
   } else {
     $r=($c - $t)*2;
     $result.="\t\t<td colspan=$r><hr width=75%></td>\n\t</tr>\n</table>\n";
   }
    return($result);
  }

  function z_CheckBoxesArray($handle, $SourceArray) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $l      = strlen($handle);
    $result = array();
    while (list($k,$v)= each($SourceArray)) {
      if (!strncmp($k,$handle,$l)) {
        $checked = substr($k, $l); 
        // print "<br> |$k|$v|$handle| ($checked)";   
        array_push($result, $checked);
      }
    }
    return($result);
  }

  function z_OrderedListArray($handle, $SourceArray) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $l      = strlen($handle);
    $result = array();
    while (list($k,$v)= each($SourceArray)) {
      if (!strncmp($k,$handle,$l)) {
        $checked = substr($k, $l); 
        // print "<br> |$k|$v|$handle| ($checked)";   
        $result[$checked] = $v;
      }
    }
    return($result);
  }

  function z_FormatFormDate($formatString, $datename, $SourceArray) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $day   = $SourceArray[$datename.'_day'];
    $month = $SourceArray[$datename.'_month'];
    $year  = $SourceArray[$datename.'_year'];
    return(date($formatString, mktime(0,0,0,$month,$day,$year)));
  }

  function z_MysqlDateRange($fieldName,$SourceArray) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $fromDate = z_FormatFormDate("Ymd000000",$fieldName .'_from',$SourceArray);
    $toDate   = z_FormatFormDate("Ymd000000",$fieldName .'_to',$SourceArray);
    $result   = " ( (bugs.$fieldName >= $fromDate)&&(bugs.$fieldName<=$toDate) ) ";
    return($result);
  }

  function z_ParseQueryArguments($SourceArray) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    $ScalarVars = array("product","component","priority","severity","status",
		        "resolution","reporter","assigned");
    $Parameters = array();
    while (list($k,$v) = each ($ScalarVars) ) {
      if (isset($SourceArray[$v])) {
        if ($SourceArray[$v] > -1) {
          array_push($Parameters," (bugs.$v = ".$SourceArray[$v].") ");
        }
        // if ($SourceArray[$v] > -1) print ("\n<br> (bugs.$v = ".$SourceArray[$v].") "); 	
      }
    }
    if (isset($SourceArray['mrange'])) {
      if ($SourceArray['mrange']) {
        array_push($Parameters,z_MysqlDateRange('modified',$SourceArray) );
      }
    }
    if (isset($SourceArray['crange'])) {
      if ($SourceArray['crange']) {
        array_push($Parameters,z_MysqlDateRange('creation',$SourceArray) );
      }
    }
    return($Parameters);
  }


  function z_ComposeQuery($Parameters,$SortList) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    // substitute for what's defined.
    $user_options = NULL;
    while (list($k,$v) = each ($Parameters)) {
      $user_options .= $v . " and "; 
    }
    $user_options .= " (1=1) ";

    $InOrder       = 0; 
    $ORDER_BY_LIST = ' order by ';
    while (list($k,$v) = each ($SortList)) {
      if (strlen($v)>0) {
        $InOrder = 1;
        $ORDER_BY_LIST .= $v . ',';
      }
    }
    if ($InOrder) {
      $p = strrpos($ORDER_BY_LIST,',');
      if ($p) {
        $ORDER_BY_LIST = substr($ORDER_BY_LIST,0,$p);
      }
    } else {
      $ORDER_BY_LIST = '';
    }

    $query = "\nselect bid, cc, private, url, products.name product, components.name component, versions.name version, shortdesc, severity_d.name severity,  "
           . "\n priority_d.name priority, status_d.name status, resolve_d.name resolution, u1.name assigned, u2.name reporter ,  "
           . "\n DATE_FORMAT(creation,\"%b. %e,%Y\") creation, DATE_FORMAT(modified,\"%b. %e,%Y\") modified "
           . "\n from bugs,products,components,versions,status_d,priority_d,severity_d, users u1, users u2 "
           . "\n left join resolve_d on resolve_d.id = resolution "
           . "\n where status_d.id = status and bugs.severity = severity_d.id and priority = priority_d.id "
           . "\n and bugs.product = products.pid and component = components.cid and version = versions.vid " 
           . "\n and u1.uid = bugs.assigned and u2.uid = bugs.reporter "
           . "\n and ($user_options) "
           . "\n $ORDER_BY_LIST ";
    return($query);
  }

  function z_PrintResultSet($Columns, $Query) {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $_CONF, $_USER, $db, $config;

    $db->query($Query);

    print("<table>");
    print("<tr bgcolor=" . $config['barcol1'] . ">");
    reset($Columns);
    $innercol = $Columns;

    while (list($k, $v) = each($Columns)) {
      if (strlen($v) > 0) {
        print("<td><font size=-1><b>$v</b></font></td>"); 
      }
    }
    print("</tr>"); 

    while ($db->next_record()) {
      reset($innercol);
      print("<tr>"); 
      while (list($k, $v) = each($innercol)) {
        if (strlen($v)>0) {
          if (strcmp($v,'bid')) {
            $record = stripcslashes($db->record[$v]);
            if ($v == "private") {
              if ($db->record[$v] == 0) {
                $record = "NO";
              } else {
                $record = "YES";
              }
            }
            print("<td bgcolor=#f2f2f2> <font size=-1>$record</font> </td>");
          } else {
            print("<td bgcolor=#f2f2f2> <font size=-1><a href=\"query.php?bug=" . $db->record['bid'] . "\">" . $db->record['bid'] . "</font></td>");
          }
        }
      }
      print("</tr>");
    }
    print("</table>");
  }

  function z_ShowSelectionGrid() {
    // code for this function under GPL and contributed/copyright
    // by Ali Ziad
    global $config;

    print "<center><form action=query.php method=post>";
    print "<table bgcolor=#dae2ea cellpadding=0 border=1 width=640>";
    print "<tr><td align=center valign=middle><br>";
    print "<table bgcolor=#dae2ea cellpadding=3 border=1 width=600>";
    print "<tr><td>Product   </td><td>" . z_MakeDropDown("product","products","pid","name",1) . "</td>";
    print "<td>Component </td><td>" . z_MakeDropDown("component","components","cid","name",1) . "</td></tr>";
    print "<tr><td>Priority </td><td>" . z_MakeDropDown("priority","priority_d","id","name",0) ."</td>";
    print "    <td>Severity </td><td>" . z_MakeDropDown("severity","severity_d","id","name",0) ."</td></tr>";
    print "<tr><td>Status   </td><td>" . z_MakeDropDown("status","status_d","id","name",0) . "</td>";
    print "<td> Resolution </td><td>" . z_MakeDropDown("resolution","resolve_d","id","name",0) . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td colspan=4> <input type=radio name=crange value=0 checked> Submited anytime !</td></tr>";
    print "<tr><td> <input type=radio name=crange value=1> Between </td> " 
         ."<td>" . z_MakeDateRangeDropDown("creation_from") . "</td>";
    print "<td> And </td><td>" . z_MakeDateRangeDropDown("creation_to") . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td colspan=4> <input type=radio name=mrange value=0 checked> Modified anytime !</td></tr>";
    print "<tr><td> <input type=radio name=mrange value=1> Between </td> " 
         ."<td>" . z_MakeDateRangeDropDown("modified_from") . "</td>";
    print "<td> And </td><td>" . z_MakeDateRangeDropDown("modified_to") . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=1 width=600>";
    print "<tr><td> Reported By   </td><td>" . z_MakeDropDown("reporter","users","uid","name",1) . "</td>";
    print "<td> Assigned To </td><td>" . z_MakeDropDown("assigned","users","uid","name",1) . "</td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td> Fields to Display: <b><br><font size=-2> ";
    print z_MakeSelectFieldsList("bugs") . "</font></td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "<tr><td> Sort Fields<br> <b><font size=1>";
    print  z_MakeSortFieldsList("bugs") . "</font></td></tr>";
    print "</table>";

    print "<table bgcolor=#dae2ea cellpadding=3 border=0 width=600>";
    print "\n<tr><td colspan=2>&nbsp;</td></tr>";
    print "<tr><td align=center><input type=submit name=btnQuery value=\"Run Query\"></td></tr>";
    print "</table>";
    print "</td></tr></table>";
    print "</form></center>";
    print "<br>";
  }

  function d_doQuery($uid, $type) {
    if ($type == "a") {
      print("<p>" . gettext("Advanced bug searching and reporting capabilities query.") . "</p>");
      z_ShowSelectionGrid();
      print("<p><a href=\"$PHP_SELF?z=s\">" . gettext("Simple bug search") . "</a></p>");
    } else {
      print("<p>" . gettext("Simple bug searching and reporting query.") . "</p>");
      d_DrawQueryForm($uid);
      print("<p><a href=\"$PHP_SELF?z=a\">" . gettext("Advanced bug search") . "</a></p>");
    }
  }

  function d_DumpVdiff($product, $data) {
    print(sprintf("<tr><td><a href=\"query.php?bug=%s\">%s</a></td>",$data['bid'],$data['bid']));
    print("<td>$product</td>");
    print("<td>" . $data['fixedver'] . "</td>");
    print("<td>" . $data['shortdesc'] . "</td></tr>");
  }

  function d_AskVersion($product) {
    global $db;

    $db->query("SELECT * FROM products WHERE pid = '$product'");
    $db->next_record();
    $pname = $db->record['name'];
    $db->free();

    print("<p>" . sprintf(gettext("Requested difference between versions  for %s..."), $pname) . "</p>");
?>
    <form method="post" action="buglist.php">
    <input type="hidden" name="product" value=<? print($product); ?>">
    <table cellpadding="0" cellspacing="0" border="0" width="100%">
      <tr>
        <td valign="center">
          <? print(gettext("Check differences between version ")); ?>
          <input type="text" name="sversion" size="8" maxsize="8">  
          <? print(" " . gettext("and version") . " "); ?>
          <input type="text" name="eversion" size="8" maxsize="8">  
        </td>
        <tr>
        <tr>
          <td>
            <br /><input type="submit" value="<? print(gettext("Check")); ?>">
          </td>
        </tr>
      </table>
      </form>
<?
  }
  
  function d_DrawRules() {
    t_rules();
    t_rulesbutton();
  }

?>
