<?
   // Anthill MySQL connection class
   // $Id: mysql.class.php,v 1.5 2002/07/24 21:35:21 vdanen Exp $

class db_Sql {
  // define connection info
  var $type   = "mysql";
  var $host   = "";
  var $dbase  = "";
  var $user   = "";
  var $passwd = "";

  // some config items
  var $debug         = 0; // 1=debug messages, 0=off
  // How to handle errors:
  // 0 = ignore errors
  // 1 = halt with message
  // 2 = ignore error, but print a warning
  var $halt_on_error = 1;
  var $auto_free     = 0; // 1 = auto mysql_free_result()

  // result array and current row number
  var $record = array();
  var $row    = "";

  // current error number and text
  var $errno  = 0;
  var $error  = "";

  // link and query handles
  var $link_id  = 0;
  var $query_id = 0;

  // constructor
  function db_Sql($query = "") {
    $this->query($query);
  }

  // reporting
  function link_id() {
    return $this->link_id;
  }

  function query_id() {
    return $this->query_id;
  }

  // connection management
  function connect($dbase = "", $host = "", $user = "", $passwd = "") {
    // defaults
    if($dbase == "") {
      $dbase = $this->dbase;
    }
    if($host == "") {
      $host = $this->host;
    }
    if($user == "") {
      $user = $this->user;
    }
    if($passwd == "") {
      $passwd = $this->passwd;
    }

    // make connection
    if($this->link_id == 0) {
      $this->link_id = mysql_pconnect($host, $user, $passwd);
      if(!$this->link_id) {
        $this->halt("pconnect($host, $user, \$passwd) failed.");
        return 0;
      }
      if(!@mysql_select_db($dbase,$this->link_id)) {
        $this->halt("cannot select database " . $dbase);
        return 0;
      }
    }
    return $this->link_id;
  }

  // discard query results
  function free() {
    @mysql_free_result($this->query_id);
    $this->query_id = 0;
  }

  // perform a query
  function query($query_string) {
    if($query_string == "") {
      // no empty queries allowed
      return 0;
    }
    if(!$this->connect()) {
      return 0;
    }
    if($this->query_id) {
      // this is a new query so get rid of old results
      $this->free();
    }
    if($this->debug) {
      printf("Debug: query = %s<br>\n", $query_string);
    }

    $this->query_id = @mysql_query($query_string,$this->link_id);
    $this->row      = 0;
    $this->errno    = mysql_errno();
    $this->error    = mysql_error();
    if(!$this->query_id) {
      $this->halt("Invalid SQL: " . $query_string);
    }
    return $this->query_id;
  }

  function affected_rows() {
    return @mysql_affected_rows($this->link_id);
  }

  function num_rows() {
    return @mysql_num_rows($this->query_id);
  }

  function num_fields() {
    return @mysql_num_fields($this->query_id);
  }

  function fetch_fieldname($num) {
    $temp = @mysql_fetch_field($this->query_id,$num);
    return $temp->name;
  }

  function next_record() {
    if(!$this->query_id) {
      $this->halt("Next record called with no pending query.");
      return 0;
    }
    $this->record = @mysql_fetch_array($this->query_id);
    $this->row   += 1;
    $this->errno  = mysql_errno();
    $this->error  = mysql_error();

    $stat = is_array($this->record);
    if(!$stat && $this->auto_free) {
      $this->free();
    }
    return $stat;
  }

  // error handling
  function halt($msg) {
    $this->error = @mysql_error($this->link_id);
    $this->errno = @mysql_errno($this->link_id);
    if($this->halt_on_error == "0") {
      return;
    }
    $this->haltmsg($msg);
    if($this->halt_on_error != "2") {
      die("Session halted.");
    }
  }

  function haltmsg($msg) {
    printf("<b>Database error:</b> %s<br>\n", $msg);
    printf("<b>MySQL Error</b>: %s (%s)<br>\n", $this->errno, $this->error);
  }
}
?>